--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas.c	Wed May  7 17:09:50 2014
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas.c	Wed May  7 17:09:50 2014
@@ -15361,27 +15345,31 @@
 	return (ptgt);
 }
 
-#ifdef MPTSAS_GET_LED
 static int
-mptsas_get_led_status(mptsas_t *mpt, mptsas_target_t *ptgt,
-    uint32_t *slotstatus)
+mptsas_flush_led_status(mptsas_t *mpt, mptsas_target_t *ptgt)
 {
-	return (mptsas_send_sep(mpt, ptgt, slotstatus,
-	    MPI2_SEP_REQ_ACTION_READ_STATUS));
-}
-#endif
-static int
-mptsas_set_led_status(mptsas_t *mpt, mptsas_target_t *ptgt, uint32_t slotstatus)
-{
+	uint32_t slotstatus = 0;
+
+	/* Build an MPI2 Slot Status based on our view of the world */
+	if (ptgt->m_led_status & (1 << (MPTSAS_LEDCTL_LED_IDENT - 1)))
+		slotstatus |= MPI2_SEP_REQ_SLOTSTATUS_IDENTIFY_REQUEST;
+	if (ptgt->m_led_status & (1 << (MPTSAS_LEDCTL_LED_FAIL - 1)))
+		slotstatus |= MPI2_SEP_REQ_SLOTSTATUS_PREDICTED_FAULT;
+	if (ptgt->m_led_status & (1 << (MPTSAS_LEDCTL_LED_OK2RM - 1)))
+		slotstatus |= MPI2_SEP_REQ_SLOTSTATUS_REQUEST_REMOVE;
+
+	/* Write it to the controller */
 	NDBG14(("mptsas_ioctl: set LED status %x for slot %x",
 	    slotstatus, ptgt->m_slot_num));
 	return (mptsas_send_sep(mpt, ptgt, &slotstatus,
 	    MPI2_SEP_REQ_ACTION_WRITE_STATUS));
 }
+
 /*
  *  send sep request, use enclosure/slot addressing
  */
-static int mptsas_send_sep(mptsas_t *mpt, mptsas_target_t *ptgt,
+static int
+mptsas_send_sep(mptsas_t *mpt, mptsas_target_t *ptgt,
     uint32_t *status, uint8_t act)
 {
 	Mpi2SepRequest_t	req;
@@ -15390,15 +15378,27 @@
 
 	ASSERT(mutex_owned(&mpt->m_mutex));
 
+	/*
+	 * We only support SEP control of directly-attached targets, in which
+	 * case the "SEP" we're talking to is a virtual one contained within
+	 * the HBA itself.  This is necessary because DA targets typically have
+	 * no other mechanism for LED control.  Targets for which a separate
+	 * enclosure service processor exists should be controlled via ses(7d)
+	 * or sgen(7d).  Furthermore, since such requests can time out, they
+	 * should be made in user context rather than in response to
+	 * asynchronous fabric changes.
+	 *
+	 * In addition, we do not support this operation for RAID volumes,
+	 * since there is no slot associated with them.
+	 */
+	if (!(ptgt->m_deviceinfo & DEVINFO_DIRECT_ATTACHED) ||
+	    ptgt->m_addr.mta_phymask == 0) {
+		return (ENOTTY);
+	}
+
 	bzero(&req, sizeof (req));
 	bzero(&rep, sizeof (rep));
 
-	/* Do nothing for RAID volumes */
-	if (ptgt->m_phymask == 0) {
-		NDBG14(("mptsas_send_sep: Skip RAID volumes"));
-		return (DDI_FAILURE);
-	}
-
 	req.Function = MPI2_FUNCTION_SCSI_ENCLOSURE_PROCESSOR;
 	req.Action = act;
 	req.Flags = MPI2_SEP_REQ_FLAGS_ENCLOSURE_SLOT_ADDRESS;
@@ -15412,26 +15412,41 @@
 	if (ret != 0) {
 		mptsas_log(mpt, CE_NOTE, "mptsas_send_sep: passthru SEP "
 		    "Processor Request message error %d", ret);
-		return (DDI_FAILURE);
+		return (ret);
 	}
 	/* do passthrough success, check the ioc status */
 	if (LE_16(rep.IOCStatus) != MPI2_IOCSTATUS_SUCCESS) {
-		if ((LE_16(rep.IOCStatus) & MPI2_IOCSTATUS_MASK) ==
-		    MPI2_IOCSTATUS_INVALID_FIELD) {
-			mptsas_log(mpt, CE_NOTE, "send sep act %x: Not "
-			    "supported action, loginfo %x", act,
-			    LE_32(rep.IOCLogInfo));
-			return (DDI_FAILURE);
-		}
 		mptsas_log(mpt, CE_NOTE, "send_sep act %x: ioc "
-		    "status:%x", act, LE_16(rep.IOCStatus));
-		return (DDI_FAILURE);
+		    "status:%x loginfo %x", act, LE_16(rep.IOCStatus),
+		    LE_32(rep.IOCLogInfo));
+		switch (LE_16(rep.IOCStatus) & MPI2_IOCSTATUS_MASK) {
+		case MPI2_IOCSTATUS_INVALID_FUNCTION:
+		case MPI2_IOCSTATUS_INVALID_VPID:
+		case MPI2_IOCSTATUS_INVALID_FIELD:
+		case MPI2_IOCSTATUS_INVALID_STATE:
+		case MPI2_IOCSTATUS_OP_STATE_NOT_SUPPORTED:
+		case MPI2_IOCSTATUS_CONFIG_INVALID_ACTION:
+		case MPI2_IOCSTATUS_CONFIG_INVALID_TYPE:
+		case MPI2_IOCSTATUS_CONFIG_INVALID_PAGE:
+		case MPI2_IOCSTATUS_CONFIG_INVALID_DATA:
+		case MPI2_IOCSTATUS_CONFIG_NO_DEFAULTS:
+			return (EINVAL);
+		case MPI2_IOCSTATUS_BUSY:
+			return (EBUSY);
+		case MPI2_IOCSTATUS_INSUFFICIENT_RESOURCES:
+			return (EAGAIN);
+		case MPI2_IOCSTATUS_INVALID_SGL:
+		case MPI2_IOCSTATUS_INTERNAL_ERROR:
+		case MPI2_IOCSTATUS_CONFIG_CANT_COMMIT:
+		default:
+			return (EIO);
+		}
 	}
 	if (act != MPI2_SEP_REQ_ACTION_WRITE_STATUS) {
 		*status = LE_32(rep.SlotStatus);
 	}
 
-	return (DDI_SUCCESS);
+	return (0);
 }
 
 int
--- /dev/null	Wed May  7 17:09:52 2014
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas_hash.c	Wed May  7 17:09:52 2014
@@ -0,0 +1,215 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2014 Joyent, Inc.  All rights reserved.
+ */
+
+#include <sys/scsi/adapters/mpt_sas/mptsas_hash.h>
+#include <sys/sysmacros.h>
+#include <sys/types.h>
+#include <sys/kmem.h>
+#include <sys/list.h>
+#include <sys/ddi.h>
+
+#ifdef lint
+extern refhash_link_t *obj_to_link(refhash_t *, void *);
+extern void *link_to_obj(refhash_t *, refhash_link_t *);
+extern void *obj_to_tag(refhash_t *, void *);
+#else
+#define	obj_to_link(_h, _o)	\
+	((refhash_link_t *)(((char *)(_o)) + (_h)->rh_link_off))
+#define	link_to_obj(_h, _l)	\
+	((void *)(((char *)(_l)) - (_h)->rh_link_off))
+#define	obj_to_tag(_h, _o)	\
+	((void *)(((char *)(_o)) + (_h)->rh_tag_off))
+#endif
+
+refhash_t *
+refhash_create(uint_t bucket_count, refhash_hash_f hash,
+    refhash_cmp_f cmp, refhash_dtor_f dtor, size_t obj_size, size_t link_off,
+    size_t tag_off, int km_flags)
+{
+	refhash_t *hp;
+	uint_t i;
+
+	hp = kmem_alloc(sizeof (refhash_t), km_flags);
+	if (hp == NULL)
+		return (NULL);
+	hp->rh_buckets = kmem_zalloc(bucket_count * sizeof (list_t), km_flags);
+	if (hp->rh_buckets == NULL) {
+		kmem_free(hp, sizeof (refhash_t));
+		return (NULL);
+	}
+	hp->rh_bucket_count = bucket_count;
+
+	for (i = 0; i < bucket_count; i++) {
+		list_create(&hp->rh_buckets[i], sizeof (refhash_link_t),
+		    offsetof(refhash_link_t, rhl_chain_link));
+	}
+	list_create(&hp->rh_objs, sizeof (refhash_link_t),
+	    offsetof(refhash_link_t, rhl_global_link));
+
+	hp->rh_obj_size = obj_size;
+	hp->rh_link_off = link_off;
+	hp->rh_tag_off = tag_off;
+	hp->rh_hash = hash;
+	hp->rh_cmp = cmp;
+	hp->rh_dtor = dtor;
+
+	return (hp);
+}
+
+void
+refhash_destroy(refhash_t *hp)
+{
+	ASSERT(list_is_empty(&hp->rh_objs));
+
+	kmem_free(hp->rh_buckets, hp->rh_bucket_count * sizeof (list_t));
+	kmem_free(hp, sizeof (refhash_t));
+}
+
+void
+refhash_insert(refhash_t *hp, void *op)
+{
+	uint_t bucket;
+	refhash_link_t *lp = obj_to_link(hp, op);
+
+	bucket = hp->rh_hash(obj_to_tag(hp, op)) % hp->rh_bucket_count;
+	list_link_init(&lp->rhl_chain_link);
+	list_link_init(&lp->rhl_global_link);
+	lp->rhl_flags = 0;
+	lp->rhl_refcnt = 0;
+	list_insert_tail(&hp->rh_buckets[bucket], lp);
+	list_insert_tail(&hp->rh_objs, lp);
+}
+
+static void
+refhash_delete(refhash_t *hp, void *op)
+{
+	refhash_link_t *lp = obj_to_link(hp, op);
+	uint_t bucket;
+
+	bucket = hp->rh_hash(obj_to_tag(hp, op)) % hp->rh_bucket_count;
+	list_remove(&hp->rh_buckets[bucket], lp);
+	list_remove(&hp->rh_objs, lp);
+	hp->rh_dtor(op);
+}
+
+void
+refhash_remove(refhash_t *hp, void *op)
+{
+	refhash_link_t *lp = obj_to_link(hp, op);
+
+	if (lp->rhl_refcnt > 0) {
+		lp->rhl_flags |= RHL_F_DEAD;
+	} else {
+		refhash_delete(hp, op);
+	}
+}
+
+void *
+refhash_lookup(refhash_t *hp, const void *tp)
+{
+	uint_t bucket;
+	refhash_link_t *lp;
+	void *op;
+
+	bucket = hp->rh_hash(tp) % hp->rh_bucket_count;
+	for (lp = list_head(&hp->rh_buckets[bucket]); lp != NULL;
+	    lp = list_next(&hp->rh_buckets[bucket], lp)) {
+		op = link_to_obj(hp, lp);
+		if (hp->rh_cmp(obj_to_tag(hp, op), tp) == 0 &&
+		    !(lp->rhl_flags & RHL_F_DEAD)) {
+			return (op);
+		}
+	}
+
+	return (NULL);
+}
+
+void *
+refhash_linear_search(refhash_t *hp, refhash_eval_f eval, void *arg)
+{
+	void *op;
+	refhash_link_t *lp;
+
+	for (lp = list_head(&hp->rh_objs); lp != NULL;
+	    lp = list_next(&hp->rh_objs, lp)) {
+		op = link_to_obj(hp, lp);
+		if (eval(op, arg) == 0)
+			return (op);
+	}
+
+	return (NULL);
+}
+
+void
+refhash_hold(refhash_t *hp, void *op)
+{
+	refhash_link_t *lp = obj_to_link(hp, op);
+
+	++lp->rhl_refcnt;
+}
+
+void
+refhash_rele(refhash_t *hp, void *op)
+{
+	refhash_link_t *lp = obj_to_link(hp, op);
+
+	ASSERT(lp->rhl_refcnt > 0);
+
+	if (--lp->rhl_refcnt == 0 && (lp->rhl_flags & RHL_F_DEAD))
+		refhash_remove(hp, op);
+}
+
+void *
+refhash_first(refhash_t *hp)
+{
+	refhash_link_t *lp;
+
+	lp = list_head(&hp->rh_objs);
+	if (lp == NULL)
+		return (NULL);
+
+	++lp->rhl_refcnt;
+
+	return (link_to_obj(hp, lp));
+}
+
+void *
+refhash_next(refhash_t *hp, void *op)
+{
+	refhash_link_t *lp;
+
+	lp = obj_to_link(hp, op);
+	while ((lp = list_next(&hp->rh_objs, lp)) != NULL) {
+		if (!(lp->rhl_flags & RHL_F_DEAD))
+			break;
+	}
+
+	refhash_rele(hp, op);
+	if (lp == NULL)
+		return (NULL);
+
+	++lp->rhl_refcnt;
+
+	return (link_to_obj(hp, lp));
+}
+
+boolean_t
+refhash_obj_valid(refhash_t *hp, const void *op)
+{
+	/* LINTED - E_ARG_INCOMPATIBLE_WITH_ARG_L */
+	const refhash_link_t *lp = obj_to_link(hp, op);
+
+	return ((lp->rhl_flags & RHL_F_DEAD) != 0);
+}
--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas_impl.c	Wed May  7 17:09:52 2014
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas_impl.c	Wed May  7 17:09:52 2014
@@ -1529,7 +1529,7 @@
 	    MPI2_CONFIG_ACTION_PAGE_READ_CURRENT,
 	    MPI2_CONFIG_EXTPAGETYPE_SAS_EXPANDER, 0, page_address,
 	    mptsas_sasexpdpage_0_cb, page_address, &info->m_devhdl,
-	    &info->m_sasaddr, &info->m_phymask, &info->m_pdevhdl);
+	    &info->m_addr.mta_wwn, &info->m_addr.mta_phymask, &info->m_pdevhdl);
 
 	return (rval);
 }
--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas_raid.c	Wed May  7 17:09:53 2014
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas_raid.c	Wed May  7 17:09:53 2014
@@ -91,7 +91,7 @@
 
 extern int mptsas_check_dma_handle(ddi_dma_handle_t handle);
 extern int mptsas_check_acc_handle(ddi_acc_handle_t handle);
-extern mptsas_target_t *mptsas_tgt_alloc(mptsas_hash_table_t *, uint16_t,
+extern mptsas_target_t *mptsas_tgt_alloc(mptsas_t *, uint16_t,
     uint64_t, uint32_t, mptsas_phymask_t, uint8_t);
 
 static int
@@ -110,7 +110,6 @@
 	uint16_t elementtype, voldevhandle;
 	uint16_t etype_vol, etype_pd, etype_hs;
 	uint16_t etype_oce;
-	mptsas_slots_t *slots = mpt->m_active;
 	m_raidconfig_t *raidconfig;
 	uint64_t raidwwn;
 	uint32_t native;
@@ -148,8 +147,8 @@
 	 * Point to the right config in the structure.
 	 * Increment the number of valid RAID configs.
 	 */
-	raidconfig = &slots->m_raidconfig[configindex];
-	slots->m_num_raid_configs++;
+	raidconfig = &mpt->m_raidconfig[configindex];
+	mpt->m_num_raid_configs++;
 
 	/*
 	 * Set the native flag if this is not a foreign
@@ -216,7 +215,7 @@
 			/*
 			 * RAID uses phymask of 0.
 			 */
-			ptgt = mptsas_tgt_alloc(&slots->m_tgttbl,
+			ptgt = mptsas_tgt_alloc(mpt,
 			    voldevhandle, raidwwn, 0, 0, 0);
 
 			raidconfig->m_raidvol[vol].m_raidtgt =
@@ -258,7 +257,6 @@
 	int rval = DDI_SUCCESS;
 	uint32_t confignum, pageaddress;
 	uint8_t configindex;
-	mptsas_slots_t *slots = mpt->m_active;
 
 	ASSERT(mutex_owned(&mpt->m_mutex));
 
@@ -265,8 +263,8 @@
 	/*
 	 * Clear all RAID info before starting.
 	 */
-	bzero(slots->m_raidconfig, sizeof (slots->m_raidconfig));
-	slots->m_num_raid_configs = 0;
+	bzero(mpt->m_raidconfig, sizeof (mpt->m_raidconfig));
+	mpt->m_num_raid_configs = 0;
 
 	configindex = 0;
 	confignum = 0xff;
@@ -466,7 +464,6 @@
 		raidvol->m_raidwwid = sas_wwn;
 	}
 
-done:
 	return (rval);
 }
 
@@ -586,10 +583,10 @@
 	 * supports IR and make sure there is a valid volume for the request.
 	 */
 	if (mpt->m_ir_capable) {
-		for (config = 0; (config < slots->m_num_raid_configs) &&
+		for (config = 0; (config < mpt->m_num_raid_configs) &&
 		    (!ir_active); config++) {
 			for (vol = 0; vol < MPTSAS_MAX_RAIDVOLS; vol++) {
-				if (slots->m_raidconfig[config].m_raidvol[vol].
+				if (mpt->m_raidconfig[config].m_raidvol[vol].
 				    m_israid) {
 					ir_active = TRUE;
 					break;
@@ -758,12 +755,11 @@
 mptsas_delete_volume(mptsas_t *mpt, uint16_t volid)
 {
 	int		config, i = 0, vol = (-1);
-	mptsas_slots_t	*slots = mpt->m_active;
 
-	for (config = 0; (config < slots->m_num_raid_configs) && (vol != i);
+	for (config = 0; (config < mpt->m_num_raid_configs) && (vol != i);
 	    config++) {
 		for (i = 0; i < MPTSAS_MAX_RAIDVOLS; i++) {
-			if (slots->m_raidconfig[config].m_raidvol[i].
+			if (mpt->m_raidconfig[config].m_raidvol[i].
 			    m_raidhandle == volid) {
 				vol = i;
 				break;
@@ -777,11 +773,11 @@
 		return (-1);
 	}
 
-	slots->m_raidconfig[config].m_raidvol[vol].m_israid = 0;
-	slots->m_raidconfig[config].m_raidvol[vol].m_ndisks = 0;
+	mpt->m_raidconfig[config].m_raidvol[vol].m_israid = 0;
+	mpt->m_raidconfig[config].m_raidvol[vol].m_ndisks = 0;
 	for (i = 0; i < MPTSAS_MAX_DISKS_IN_VOL; i++) {
-		slots->m_raidconfig[config].m_raidvol[vol].m_disknum[i] = 0;
-		slots->m_raidconfig[config].m_raidvol[vol].m_devhdl[i] = 0;
+		mpt->m_raidconfig[config].m_raidvol[vol].m_disknum[i] = 0;
+		mpt->m_raidconfig[config].m_raidvol[vol].m_devhdl[i] = 0;
 	}
 
 	return (0);
--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas_smhba.c	Wed May  7 17:09:53 2014
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas_smhba.c	Wed May  7 17:09:53 2014
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 2009, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2013 Nexenta Systems, Inc. All rights reserved.
  */
 /*
  * This file contains SM-HBA support for MPT SAS driver
@@ -59,6 +60,11 @@
  */
 extern char *mptsas_driver_rev;
 
+static void mptsas_smhba_create_phy_props(nvlist_t **, smhba_info_t *, uint8_t,
+    uint16_t *);
+static void mptsas_smhba_update_phy_props(mptsas_t *, dev_info_t *, nvlist_t **,
+    uint8_t);
+
 static void
 mptsas_smhba_add_hba_prop(mptsas_t *mpt, data_type_t dt,
     char *prop_name, void *prop_val);
@@ -116,79 +122,48 @@
 	}
 }
 
-void
-mptsas_smhba_set_phy_props(mptsas_t *mpt, char *iport, dev_info_t *dip,
-    uint8_t phy_nums, uint16_t *attached_devhdl)
+static void
+mptsas_smhba_create_phy_props(nvlist_t **phy_props, smhba_info_t *pSmhba,
+    uint8_t phy_id, uint16_t *attached_devhdl)
 {
-	int		i;
-	int		j = 0;
+	(void) nvlist_alloc(phy_props, NV_UNIQUE_NAME, KM_SLEEP);
+	(void) nvlist_add_uint8(*phy_props, SAS_PHY_ID, phy_id);
+	(void) nvlist_add_uint8(*phy_props, "phyState",
+	    (pSmhba->negotiated_link_rate & 0x0f));
+	(void) nvlist_add_int8(*phy_props, SAS_NEG_LINK_RATE,
+	    (pSmhba->negotiated_link_rate & 0x0f));
+	(void) nvlist_add_int8(*phy_props, SAS_PROG_MIN_LINK_RATE,
+	    (pSmhba->programmed_link_rate & 0x0f));
+	(void) nvlist_add_int8(*phy_props, SAS_HW_MIN_LINK_RATE,
+	    (pSmhba->hw_link_rate & 0x0f));
+	(void) nvlist_add_int8(*phy_props, SAS_PROG_MAX_LINK_RATE,
+	    ((pSmhba->programmed_link_rate & 0xf0) >> 4));
+	(void) nvlist_add_int8(*phy_props, SAS_HW_MAX_LINK_RATE,
+	    ((pSmhba->hw_link_rate & 0xf0) >> 4));
+
+	if (pSmhba->attached_devhdl && (attached_devhdl != NULL))
+		*attached_devhdl = pSmhba->attached_devhdl;
+}
+
+static void
+mptsas_smhba_update_phy_props(mptsas_t *mpt, dev_info_t *dip,
+    nvlist_t **phy_props, uint8_t phy_nums)
+{
 	int		rval;
 	size_t		packed_size;
 	char		*packed_data = NULL;
-	char		phymask[MPTSAS_MAX_PHYS];
-	nvlist_t	**phy_props;
 	nvlist_t	*nvl;
-	smhba_info_t	*pSmhba = NULL;
 
-	if (phy_nums == 0) {
+	if (nvlist_alloc(&nvl, NV_UNIQUE_NAME, KM_SLEEP) != 0) {
+		mptsas_log(mpt, CE_WARN, "%s: nvlist_alloc() failed", __func__);
 		return;
 	}
-	if (nvlist_alloc(&nvl, NV_UNIQUE_NAME, 0) != 0) {
-		mptsas_log(mpt, CE_WARN, "%s: nvlist_alloc() failed", __func__);
-	}
 
-	phy_props = kmem_zalloc(sizeof (nvlist_t *) * phy_nums,
-	    KM_SLEEP);
-
-	for (i = 0; i < mpt->m_num_phys; i++) {
-
-		bzero(phymask, sizeof (phymask));
-		(void) sprintf(phymask, "%x", mpt->m_phy_info[i].phy_mask);
-		if (strcmp(phymask, iport) == 0) {
-			pSmhba = &mpt->m_phy_info[i].smhba_info;
-			(void) nvlist_alloc(&phy_props[j], NV_UNIQUE_NAME, 0);
-			(void) nvlist_add_uint8(phy_props[j], SAS_PHY_ID, i);
-			(void) nvlist_add_uint8(phy_props[j],
-			    "phyState",
-			    (pSmhba->negotiated_link_rate
-			    & 0x0f));
-			(void) nvlist_add_int8(phy_props[j],
-			    SAS_NEG_LINK_RATE,
-			    (pSmhba->negotiated_link_rate
-			    & 0x0f));
-			(void) nvlist_add_int8(phy_props[j],
-			    SAS_PROG_MIN_LINK_RATE,
-			    (pSmhba->programmed_link_rate
-			    & 0x0f));
-			(void) nvlist_add_int8(phy_props[j],
-			    SAS_HW_MIN_LINK_RATE,
-			    (pSmhba->hw_link_rate
-			    & 0x0f));
-			(void) nvlist_add_int8(phy_props[j],
-			    SAS_PROG_MAX_LINK_RATE,
-			    ((pSmhba->programmed_link_rate
-			    & 0xf0) >> 4));
-			(void) nvlist_add_int8(phy_props[j],
-			    SAS_HW_MAX_LINK_RATE,
-			    ((pSmhba->hw_link_rate
-			    & 0xf0) >> 4));
-
-			j++;
-
-			if (pSmhba->attached_devhdl &&
-			    (attached_devhdl != NULL)) {
-				*attached_devhdl =
-				    pSmhba->attached_devhdl;
-			}
-		}
-	}
-
 	rval = nvlist_add_nvlist_array(nvl, SAS_PHY_INFO_NVL, phy_props,
 	    phy_nums);
 	if (rval) {
 		mptsas_log(mpt, CE_WARN,
-		    " nv list array add failed, return value %d.",
-		    rval);
+		    " nv list array add failed, return value %d.", rval);
 		goto exit;
 	}
 	(void) nvlist_size(nvl, &packed_size, NV_ENCODE_NATIVE);
@@ -200,11 +175,7 @@
 	    SAS_PHY_INFO, (uchar_t *)packed_data, packed_size);
 
 exit:
-	for (i = 0; i < phy_nums && phy_props[i] != NULL; i++) {
-		nvlist_free(phy_props[i]);
-	}
 	nvlist_free(nvl);
-	kmem_free(phy_props, sizeof (nvlist_t *) * phy_nums);
 
 	if (packed_data != NULL) {
 		kmem_free(packed_data, packed_size);
@@ -211,6 +182,47 @@
 	}
 }
 
+void
+mptsas_smhba_set_one_phy_props(mptsas_t *mpt, dev_info_t *dip, uint8_t phy_id,
+    uint16_t *attached_devhdl)
+{
+	nvlist_t	*phy_props;
+
+	ASSERT(phy_id < mpt->m_num_phys);
+
+	mptsas_smhba_create_phy_props(&phy_props,
+	    &mpt->m_phy_info[phy_id].smhba_info, phy_id, attached_devhdl);
+
+	mptsas_smhba_update_phy_props(mpt, dip, &phy_props, 1);
+
+	nvlist_free(phy_props);
+}
+
+void
+mptsas_smhba_set_all_phy_props(mptsas_t *mpt, dev_info_t *dip, uint8_t phy_nums,
+    mptsas_phymask_t phy_mask, uint16_t *attached_devhdl)
+{
+	int		i, j;
+	nvlist_t	**phy_props;
+
+	if (phy_nums == 0)
+		return;
+
+	phy_props = kmem_zalloc(sizeof (nvlist_t *) * phy_nums, KM_SLEEP);
+
+	for (i = 0, j = 0; i < mpt->m_num_phys && j < phy_nums; i++)
+		if (phy_mask == mpt->m_phy_info[i].phy_mask)
+			mptsas_smhba_create_phy_props(&phy_props[j++],
+			    &mpt->m_phy_info[i].smhba_info, i, attached_devhdl);
+
+	mptsas_smhba_update_phy_props(mpt, dip, phy_props, j);
+
+	for (i = 0; i < j && phy_props[i] != NULL; i++)
+		nvlist_free(phy_props[i]);
+
+	kmem_free(phy_props, sizeof (nvlist_t *) * phy_nums);
+}
+
 /*
  * Called with PHY lock held on phyp
  */
--- old/usr/src/uts/common/sys/lpif.h	Wed May  7 17:09:53 2014
+++ new/usr/src/uts/common/sys/lpif.h	Wed May  7 17:09:53 2014
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2013 by Delphix. All rights reserved.
  */
 #ifndef	_LPIF_H
 #define	_LPIF_H
@@ -131,9 +132,6 @@
 stmf_status_t stmf_set_lu_access(stmf_lu_t *lup, uint8_t access_state);
 stmf_status_t stmf_proxy_scsi_cmd(scsi_task_t *, stmf_data_buf_t *dbuf);
 int stmf_is_standby_port(scsi_task_t *);
-void stmf_lu_xfer_start(struct scsi_task *task);
-void stmf_lu_xfer_done(struct scsi_task *task, boolean_t read,
-    uint64_t xfer_bytes, hrtime_t elapsed_time);
 
 #ifdef	__cplusplus
 }
--- /dev/null	Wed May  7 17:09:53 2014
+++ new/usr/src/uts/common/sys/scsi/adapters/mpt_sas/mptsas_hash.h	Wed May  7 17:09:53 2014
@@ -0,0 +1,61 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2014 Joyent, Inc.  All rights reserved.
+ */
+
+#ifndef	_SYS_SCSI_ADAPTERS_MPTHASH_H
+#define	_SYS_SCSI_ADAPTERS_MPTHASH_H
+
+#include <sys/types.h>
+#include <sys/list.h>
+
+#define	RHL_F_DEAD	0x01
+
+typedef struct refhash_link {
+	list_node_t rhl_chain_link;
+	list_node_t rhl_global_link;
+	uint_t rhl_flags;
+	uint_t rhl_refcnt;
+} refhash_link_t;
+
+typedef uint64_t (*refhash_hash_f)(const void *);
+typedef int (*refhash_cmp_f)(const void *, const void *);
+typedef void (*refhash_dtor_f)(void *);
+typedef int (*refhash_eval_f)(const void *, void *);
+
+typedef struct refhash {
+	list_t *rh_buckets;
+	uint_t rh_bucket_count;
+	list_t rh_objs;
+	size_t rh_obj_size;	/* used by mdb */
+	size_t rh_link_off;
+	size_t rh_tag_off;
+	refhash_hash_f rh_hash;
+	refhash_cmp_f rh_cmp;
+	refhash_dtor_f rh_dtor;
+} refhash_t;
+
+extern refhash_t *refhash_create(uint_t, refhash_hash_f, refhash_cmp_f,
+    refhash_dtor_f, size_t, size_t, size_t, int);
+extern void refhash_destroy(refhash_t *);
+extern void refhash_insert(refhash_t *, void *);
+extern void refhash_remove(refhash_t *, void *);
+extern void *refhash_lookup(refhash_t *, const void *);
+extern void *refhash_linear_search(refhash_t *, refhash_eval_f, void *);
+extern void refhash_hold(refhash_t *, void *);
+extern void refhash_rele(refhash_t *, void *);
+extern void *refhash_first(refhash_t *);
+extern void *refhash_next(refhash_t *, void *);
+extern boolean_t refhash_obj_valid(refhash_t *hp, const void *);
+
+#endif	/* _SYS_SCSI_ADAPTERS_MPTHASH_H */
--- old/usr/src/uts/common/sys/scsi/adapters/mpt_sas/mptsas_ioctl.h	Wed May  7 17:09:53 2014
+++ new/usr/src/uts/common/sys/scsi/adapters/mpt_sas/mptsas_ioctl.h	Wed May  7 17:09:53 2014
@@ -23,6 +23,9 @@
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright (c) 2013, Joyent, Inc. All rights reserved.
+ */
 
 /*
  * Copyright (c) 2000 to 2010, LSI Corporation.
@@ -71,6 +74,8 @@
 #define	MPTIOCTL_GET_PCI_INFO		(MPTIOCTL | 8)
 #define	MPTIOCTL_DIAG_ACTION		(MPTIOCTL | 9)
 #define	MPTIOCTL_REG_ACCESS		(MPTIOCTL | 10)
+#define	MPTIOCTL_GET_DISK_INFO		(MPTIOCTL | 11)
+#define	MPTIOCTL_LED_CONTROL		(MPTIOCTL | 12)
 
 /*
  *  The following are our ioctl() return status values.  If everything went
@@ -296,6 +301,58 @@
 	uint32_t	RegData;
 } mptsas_reg_access_t;
 
+/*
+ * Disk Toplogy Information
+ */
+typedef struct mptsas_disk_info
+{
+	uint64_t	SasAddress;
+	uint16_t	Instance;
+	uint16_t	Enclosure;
+	uint16_t	Slot;
+} mptsas_disk_info_t;
+
+typedef struct mptsas_get_disk_info
+{
+	uint16_t		DiskCount;
+	mptsas_disk_info_t	*PtrDiskInfoArray;
+	uint64_t		DiskInfoArraySize;
+} mptsas_get_disk_info_t;
+
+#ifdef _KERNEL
+
+typedef struct mptsas_get_disk_info32
+{
+	uint16_t		DiskCount;
+	caddr32_t		PtrDiskInfoArray;
+	uint64_t		DiskInfoArraySize;
+} mptsas_get_disk_info32_t;
+
+#endif /* _KERNEL */
+
+/*
+ * LED Control
+ */
+
+typedef struct mptsas_led_control
+{
+	uint8_t		Command;
+	uint16_t	Enclosure;
+	uint16_t	Slot;
+	uint8_t		Led;
+	uint8_t		LedStatus;
+} mptsas_led_control_t;
+
+#define	MPTSAS_LEDCTL_FLAG_SET		1
+#define	MPTSAS_LEDCTL_FLAG_GET		2
+
+#define	MPTSAS_LEDCTL_LED_IDENT		1
+#define	MPTSAS_LEDCTL_LED_FAIL		2
+#define	MPTSAS_LEDCTL_LED_OK2RM		3
+
+#define	MPTSAS_LEDCTL_LED_MIN		MPTSAS_LEDCTL_LED_IDENT
+#define	MPTSAS_LEDCTL_LED_MAX		MPTSAS_LEDCTL_LED_OK2RM
+
 #ifdef  __cplusplus
 }
 #endif
--- old/usr/src/uts/common/sys/scsi/adapters/mpt_sas/mptsas_smhba.h	Wed May  7 17:09:53 2014
+++ new/usr/src/uts/common/sys/scsi/adapters/mpt_sas/mptsas_smhba.h	Wed May  7 17:09:53 2014
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 2009, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright 2013 Nexenta Systems, Inc. All rights reserved.
  */
 
 /*
@@ -63,8 +64,10 @@
  */
 int mptsas_smhba_setup(mptsas_t *);
 void mptsas_smhba_show_phy_info(mptsas_t *);
-void mptsas_smhba_set_phy_props(mptsas_t *mpt, char *iport, dev_info_t *dip,
-    uint8_t phy_nums, uint16_t *attached_devhdl);
+void mptsas_smhba_set_all_phy_props(mptsas_t *mpt, dev_info_t *dip,
+    uint8_t phy_nums, mptsas_phymask_t phy_mask, uint16_t *attached_devhdl);
+void mptsas_smhba_set_one_phy_props(mptsas_t *mpt, dev_info_t *dip,
+    uint8_t phy_id, uint16_t *attached_devhdl);
 void mptsas_smhba_log_sysevent(mptsas_t *mpt, char *subclass, char *etype,
     smhba_info_t *phyp);
 void
--- old/usr/src/uts/common/sys/scsi/adapters/mpt_sas/mptsas_var.h	Wed May  7 17:09:53 2014
+++ new/usr/src/uts/common/sys/scsi/adapters/mpt_sas/mptsas_var.h	Wed May  7 17:09:53 2014
@@ -22,6 +22,7 @@
 /*
  * Copyright (c) 2009, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2012 Nexenta Systems, Inc. All rights reserved.
+ * Copyright (c) 2013, Joyent, Inc. All rights reserved.
  */
 
 /*
@@ -58,6 +59,7 @@
 #include <sys/isa_defs.h>
 #include <sys/sunmdi.h>
 #include <sys/mdi_impldefs.h>
+#include <sys/scsi/adapters/mpt_sas/mptsas_hash.h>
 #include <sys/scsi/adapters/mpt_sas/mptsas_ioctl.h>
 #include <sys/scsi/adapters/mpt_sas/mpi/mpi2_tool.h>
 #include <sys/scsi/adapters/mpt_sas/mpi/mpi2_cnfg.h>
@@ -89,6 +91,15 @@
 #define	MPTSAS_SATA_GUID	"sata-guid"
 
 /*
+ * Hash table sizes for SMP targets (i.e., expanders) and ordinary SSP/STP
+ * targets.  There's no need to go overboard here, as the ordinary paths for
+ * I/O do not normally require hashed target lookups.  These should be good
+ * enough and then some for any fabric within the hardware's capabilities.
+ */
+#define	MPTSAS_SMP_BUCKET_COUNT		23
+#define	MPTSAS_TARGET_BUCKET_COUNT	97
+
+/*
  * MPT HW defines
  */
 #define	MPTSAS_MAX_DISKS_IN_CONFIG	14
@@ -184,14 +195,15 @@
 #define	MPTSAS_RAID_WWID(wwid) \
 	((wwid & 0x0FFFFFFFFFFFFFFF) | 0x3000000000000000)
 
+typedef struct mptsas_target_addr {
+	uint64_t mta_wwn;
+	mptsas_phymask_t mta_phymask;
+} mptsas_target_addr_t;
+
 typedef	struct mptsas_target {
-		uint64_t		m_sas_wwn;	/* hash key1 */
-		mptsas_phymask_t	m_phymask;	/* hash key2 */
-		/*
-		 * m_dr_flag is a flag for DR, make sure the member
-		 * take the place of dr_flag of mptsas_hash_data.
-		 */
-		uint8_t			m_dr_flag;	/* dr_flag */
+		mptsas_target_addr_t	m_addr;
+		refhash_link_t		m_link;
+		uint8_t			m_dr_flag;
 		uint16_t		m_devhdl;
 		uint32_t		m_deviceinfo;
 		uint8_t			m_phynum;
@@ -208,27 +220,23 @@
 		uint16_t		m_enclosure;
 		uint16_t		m_slot_num;
 		uint32_t		m_tgt_unconfigured;
+		uint8_t			m_led_status;
 
 } mptsas_target_t;
 
+/*
+ * If you change this structure, be sure that mptsas_smp_target_copy()
+ * does the right thing.
+ */
 typedef struct mptsas_smp {
-	uint64_t	m_sasaddr;	/* hash key1 */
-	mptsas_phymask_t m_phymask;	/* hash key2 */
-	uint8_t		reserved1;
-	uint16_t	m_devhdl;
-	uint32_t	m_deviceinfo;
-	uint16_t	m_pdevhdl;
-	uint32_t	m_pdevinfo;
+	mptsas_target_addr_t	m_addr;
+	refhash_link_t		m_link;
+	uint16_t		m_devhdl;
+	uint32_t		m_deviceinfo;
+	uint16_t		m_pdevhdl;
+	uint32_t		m_pdevinfo;
 } mptsas_smp_t;
 
-typedef struct mptsas_hash_data {
-	uint64_t	key1;
-	mptsas_phymask_t key2;
-	uint8_t		dr_flag;
-	uint16_t	devhdl;
-	uint32_t	device_info;
-} mptsas_hash_data_t;
-
 typedef struct mptsas_cache_frames {
 	ddi_dma_handle_t m_dma_hdl;
 	ddi_acc_handle_t m_acc_hdl;
@@ -443,17 +451,24 @@
 } m_raidconfig_t;
 
 /*
- * Structure to hold active outstanding cmds.  Also, keep
- * timeout on a per target basis.
+ * Track outstanding commands.  The index into the m_slot array is the SMID
+ * (system message ID) of the outstanding command.  SMID 0 is reserved by the
+ * software/firmware protocol and is never used for any command we generate;
+ * as such, the assertion m_slot[0] == NULL is universally true.  The last
+ * entry in the array is slot number MPTSAS_TM_SLOT(mpt) and is used ONLY for
+ * task management commands.  No normal SCSI or ATA command will ever occupy
+ * that slot.  Finally, the relationship m_slot[X]->cmd_slot == X holds at any
+ * time that a consistent view of the target array is obtainable.
+ *
+ * As such, m_n_normal is the maximum number of slots available to ordinary
+ * commands, and the relationship:
+ * mpt->m_active->m_n_normal == mpt->m_max_requests - 2
+ * always holds after initialisation.
  */
 typedef struct mptsas_slots {
-	mptsas_hash_table_t	m_tgttbl;
-	mptsas_hash_table_t	m_smptbl;
-	m_raidconfig_t		m_raidconfig[MPTSAS_MAX_RAIDCONFIGS];
-	uint8_t			m_num_raid_configs;
-	uint16_t		m_tags;
-	size_t			m_size;
-	uint16_t		m_n_slots;
+	size_t			m_size;		/* size of struct, bytes */
+	uint_t			m_n_normal;	/* see above */
+	uint_t			m_rotor;	/* next slot idx to consider */
 	mptsas_cmd_t		*m_slot[1];
 } mptsas_slots_t;
 
@@ -671,6 +686,12 @@
 	 */
 	uint_t		m_softstate;
 
+	refhash_t	*m_targets;
+	refhash_t	*m_smp_targets;
+
+	m_raidconfig_t	m_raidconfig[MPTSAS_MAX_RAIDCONFIGS];
+	uint8_t		m_num_raid_configs;
+
 	struct mptsas_slots *m_active;	/* outstanding cmds */
 
 	mptsas_cmd_t	*m_waitq;	/* cmd queue for active request */
--- old/usr/src/uts/common/sys/stmf.h	Wed May  7 17:09:53 2014
+++ new/usr/src/uts/common/sys/stmf.h	Wed May  7 17:09:53 2014
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2013 by Delphix. All rights reserved.
  */
 #ifndef	_STMF_H
 #define	_STMF_H
@@ -384,8 +385,6 @@
 stmf_status_t stmf_ctl(int cmd, void *obj, void *arg);
 stmf_status_t stmf_register_itl_handle(struct stmf_lu *lu, uint8_t *lun,
     struct stmf_scsi_session *ss, uint64_t session_id, void *itl_handle);
-stmf_status_t stmf_deregister_itl_handle(struct stmf_lu *lu, uint8_t *lun,
-    struct stmf_scsi_session *ss, uint64_t session_id, void *itl_handle);
 stmf_status_t stmf_deregister_all_lu_itl_handles(struct stmf_lu *lu);
 stmf_status_t stmf_get_itl_handle(struct stmf_lu *lu, uint8_t *lun,
     struct stmf_scsi_session *ss, uint64_t session_id, void **itl_handle_retp);
--- old/usr/src/uts/intel/mpt_sas/Makefile	Wed May  7 17:09:53 2014
+++ new/usr/src/uts/intel/mpt_sas/Makefile	Wed May  7 17:09:53 2014
@@ -62,7 +62,6 @@
 
 CERRWARN	+= -_gcc=-Wno-parentheses
 CERRWARN	+= -_gcc=-Wno-uninitialized
-CERRWARN	+= -_gcc=-Wno-unused-label
 CERRWARN	+= -_gcc=-Wno-switch
 
 #
--- old/usr/src/uts/sparc/mpt_sas/Makefile	Wed May  7 17:09:53 2014
+++ new/usr/src/uts/sparc/mpt_sas/Makefile	Wed May  7 17:09:53 2014
@@ -67,7 +67,6 @@
 
 CERRWARN	+= -_gcc=-Wno-parentheses
 CERRWARN	+= -_gcc=-Wno-uninitialized
-CERRWARN	+= -_gcc=-Wno-unused-label
 CERRWARN	+= -_gcc=-Wno-switch
 
 #
